import sys
sys.path.insert(0,"../../../Swig")
sys.path.insert(0,"../../../Python")
sys.path.insert(0,"../../../Tools")

import rumdSimulation, rumd, rumd_tools
# it is essential that there is no doubt about which version is actually run!
print "File used to import the rumd module",rumd.__file__
print "File used to import the rumdSimulation module",rumdSimulation.__file__
print "File used to import the rumd_tools module",rumd_tools.__file__

from rumdSimulation import rumdSimulation
from Autotune import Autotune

sim = rumdSimulation("startN512.xyz.gz", 32, 4, verbose=False)

# integrator
itg = rumd.IntegratorNVE(timeStep=0.005)

# Create LJ pair-potential
potential = rumd.Pot_LJ_12_6(cutoff_method=rumd.ShiftedPotential)
# Set up parameters for Lennard-Jones interactions ( Kob & Andersen )
# i  j   Sig   Eps  Rcut (in units of Sigma_ij)
potential.SetParams(0, 0, 1.0, 1.0, 2.5)
sim.SetIntegrator(itg)
sim.SetPotential(potential)

# note the technical parameters are set each time to the optimized ones
# so when it compares the new optimized ones to the "default", except in the
# first case, it is comparing to the previous set of optimized parameters
# with different parameters held fixed. Could perhaps "reset" the simulation
# to the original, "real" default parameters each time, but not sure it's
# important enough

print "================================================"
print "Fix different parameters: first pb=32, tp=2"
# (must create the autotune object again each time)
at = Autotune(ignore_file=True, pb=32, tp=2)
at.nSteps_pre_opt = (0, 0)
at.Tune(sim)
if at.ratio_opt_default > 1.05:
    exit(1)
print "================================================"
print "Fix skin=0.4"
at = Autotune(ignore_file=True, skin=0.4)
at.nSteps_pre_opt = (0, 0)
at.Tune(sim)
if at.ratio_opt_default > 1.05:
    exit(1)
print "================================================"
print "Fix NB_method=\"none\" "
at = Autotune(ignore_file=True, NB_method="none")
at.nSteps_pre_opt = (0, 0)
at.Tune(sim)
if at.ratio_opt_default > 1.05:
    exit(1)
